//
// Copyright 1994, Cray Research, Inc.
//                 
// Permission to use, copy, modify and distribute this software and
// its accompanying documentation (the "Software") is granted without
// fee, provided that the above copyright notice and this permission
// notice appear in all copies of the Software and all supporting
// documentation, and the name of Cray Research, Inc. not be used in
// advertising or publicity pertaining to distribution of the 
// Software without the prior specific, written permission of Cray
// Research, Inc.  The Software is a proprietary product of Cray
// Research, Inc., and all rights not specifically granted by this
// license shall remain in Cray Research, Inc.  No charge may be made
// for the use or distribution of the Software.  The Software may be
// distributed as a part of a different product for which a fee is
// charged, if (i) that product contains or provides substantial
// functionality that is additional to, or different from, the
// functionality of the Software, and (ii) no separate, special or
// direct charge is made for the Software.
//         
// THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
// IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
// FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
// VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
// DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
// INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
// SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
// CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
// PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
// INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
// CRAY RESEARCH.
// 
// This License Agreement shall be governed by, and interpreted and
// construed in accordance with, the laws of the State of Minnesota,
// without reference to its provisions on the conflicts of laws, and
// excluding the United Nations Convention of the International Sale
// of Goods.
//
//	USMID %Z%%M%	%I%	%G% %U%
//	$Id: Application.h++,v 1.2 1994/08/10 18:11:11 prb Exp $
//
#if	!defined(_Cvo_Application_)
#define	_Cvo_Application_

#if	!defined(_Cvo_MenuBar_)
#include <Cvo/MenuBar.h++>
#endif
#if	!defined(_Cvo_ToolTalk_)
#include <Cvo/ToolTalk.h++>
#endif

class Cvo_Application : public Cvo_Window {
    Cvo_MenuBar *bar;
    void _Init();
    void _Init(Cvo_MenuBarList *);
public:
    Cvo_Application(char *);
    Cvo_Application(char *, Cvo_MenuBarList *);
    CONSTRUCDECL(Cvo_Application)
    CONSTRUCDECL_1ARG(Cvo_Application, Cvo_MenuBarList *)
    Cvo_MenuBar *MenuBar()	{ return(bar); }

    int InitializeToolTalk();	// Initialize the ToolTalk system
    char *ToolTalkProcID()      { return(DisplayList()->ToolTalkProcID()); }
    int &ToolTalkRefCnt()	{ return(DisplayList()->ToolTalkRefCnt()); }
};

void Cvo_MenuQuit(Cvo_Object *, XEvent *, void *);
void Cvo_MenuDismiss(Cvo_Object *, XEvent *, void *);

#endif
