//
// Copyright 1994, Cray Research, Inc.
//                 
// Permission to use, copy, modify and distribute this software and
// its accompanying documentation (the "Software") is granted without
// fee, provided that the above copyright notice and this permission
// notice appear in all copies of the Software and all supporting
// documentation, and the name of Cray Research, Inc. not be used in
// advertising or publicity pertaining to distribution of the 
// Software without the prior specific, written permission of Cray
// Research, Inc.  The Software is a proprietary product of Cray
// Research, Inc., and all rights not specifically granted by this
// license shall remain in Cray Research, Inc.  No charge may be made
// for the use or distribution of the Software.  The Software may be
// distributed as a part of a different product for which a fee is
// charged, if (i) that product contains or provides substantial
// functionality that is additional to, or different from, the
// functionality of the Software, and (ii) no separate, special or
// direct charge is made for the Software.
//         
// THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
// IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
// FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
// VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
// DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
// INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
// SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
// CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
// PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
// INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
// CRAY RESEARCH.
// 
// This License Agreement shall be governed by, and interpreted and
// construed in accordance with, the laws of the State of Minnesota,
// without reference to its provisions on the conflicts of laws, and
// excluding the United Nations Convention of the International Sale
// of Goods.
//
//	USMID %Z%%M%	%I%	%G% %U%
//	$Id: MWM.h++,v 1.2 1994/08/10 18:11:11 prb Exp $
//
struct Cvo_Motif_MWM_Hints {
    CARD32          flags;
    CARD32          functions;
    CARD32          decorations;
    INT32           inputMode;
    CARD32	status;
};

#define	Cvo_Motif_MWM_Hints_size 5

#define MWM_HINTS_FUNCTIONS	0x01
#define MWM_HINTS_DECORATIONS	0x02
#define MWM_HINTS_INPUT_MODE	0x03
#define MWM_HINTS_STATUS	0x04

#define MWM_FUNC_ALL		0x01
#define MWM_FUNC_RESIZE		0x02
#define MWM_FUNC_MOVE		0x04
#define MWM_FUNC_MINIMIZE	0x08
#define MWM_FUNC_MAXIMIZE	0x10
#define MWM_FUNC_CLOSE		0x20

#define MWM_DECOR_ALL		0x01
#define MWM_DECOR_BORDER	0x02
#define MWM_DECOR_RESIZEH	0x04
#define MWM_DECOR_TITLE		0x08
#define MWM_DECOR_MENU		0x10
#define MWM_DECOR_MINIMIZE	0x20
#define MWM_DECOR_MAXIMIZE	0x40

#define MWM_INPUT_MODELESS			0
#define MWM_INPUT_PRIMARY_APPLICATION_MODAL	1
#define MWM_INPUT_SYSTEM_MODAL			2
#define MWM_INPUT_FULL_APPLICATION_MODAL	3

#define MWM_TEAROFF_WINDOW	0x01

struct Cvo_Motif_MWM_Info {
    CARD32	flags;
    CARD32	window;
};

#define	Cvo_Motif_MWM_Info_size	2

#define MWM_INFO_STARTUP_STANDARD	0x01
#define MWM_INFO_STARTUP_CUSTOM		0x02

#define _XA_MOTIF_WM_HINTS	"_MOTIF_WM_HINTS"
#define _XA_MOTIF_WM_MESSAGES	"_MOTIF_WM_MESSAGES"
#define _XA_MOTIF_WM_OFFSET	"_MOTIF_WM_OFFSET"
#define _XA_MOTIF_WM_MENU	"_MOTIF_WM_MENU"
#define _XA_MOTIF_BINDINGS	"_MOTIF_BINDINGS"
