//
// Copyright 1994, Cray Research, Inc.
//                 
// Permission to use, copy, modify and distribute this software and
// its accompanying documentation (the "Software") is granted without
// fee, provided that the above copyright notice and this permission
// notice appear in all copies of the Software and all supporting
// documentation, and the name of Cray Research, Inc. not be used in
// advertising or publicity pertaining to distribution of the 
// Software without the prior specific, written permission of Cray
// Research, Inc.  The Software is a proprietary product of Cray
// Research, Inc., and all rights not specifically granted by this
// license shall remain in Cray Research, Inc.  No charge may be made
// for the use or distribution of the Software.  The Software may be
// distributed as a part of a different product for which a fee is
// charged, if (i) that product contains or provides substantial
// functionality that is additional to, or different from, the
// functionality of the Software, and (ii) no separate, special or
// direct charge is made for the Software.
//         
// THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
// IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
// FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
// VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
// DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
// INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
// SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
// CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
// PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
// INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
// CRAY RESEARCH.
// 
// This License Agreement shall be governed by, and interpreted and
// construed in accordance with, the laws of the State of Minnesota,
// without reference to its provisions on the conflicts of laws, and
// excluding the United Nations Convention of the International Sale
// of Goods.
//
//	USMID %Z%%M%	%I%	%G% %U%
//	$Id: Radio.h++,v 1.5 1994/09/02 19:38:08 prb Exp $
//
#if	!defined(_Cvo_Radio_)
#define	_Cvo_Radio_

#if	!defined(_Cvo_RootedList_)
#include <Cvo/RootedList.h++>
#endif
#if	!defined(_Cvo_Object_)
#include <Cvo/Object.h++>
#endif

class Cvo_RadioList : public Cvo_RootedList {
public:
    Cvo_Object			*toggle;
    Cvo_Registration		*r1, *r2, *r3;
    void			*data;

public:
    Cvo_RadioList(Cvo_RadioList **, Cvo_Object *, void * = 0);
    void Delete(Cvo_RadioList **r)
				{ Unlink((Cvo_RootedList **)r); delete this; }
    Cvo_RadioList *Next()	{ return((Cvo_RadioList *)next); }
    Cvo_RadioList *Prev()	{ return((Cvo_RadioList *)prev); }
private:
    ~Cvo_RadioList();
};

class Cvo_Radio {
private:
protected:
    Cvo_RadioList		*list;
    Cvo_Object			*current;
    BOOL			require1:1;
public:

private:
protected:
public:
    Cvo_Radio()				{ list = 0; current = 0;
					  require1 = False; }
    ~Cvo_Radio();
    Cvo_Object *Current()		{ return(current); }
    Cvo_RadioList *List()		{ return(list); }
    Cvo_RadioList *AddToggle(Cvo_Object *, void * = 0);
    void DeleteToggle(Cvo_RadioList *);
    friend void _Cvo_RadioEvent(Cvo_Object *, XEvent *, void *);
    void RequireSelection(BOOL = True);
};
#endif
