//
// Copyright 1994, Cray Research, Inc.
//                 
// Permission to use, copy, modify and distribute this software and
// its accompanying documentation (the "Software") is granted without
// fee, provided that the above copyright notice and this permission
// notice appear in all copies of the Software and all supporting
// documentation, and the name of Cray Research, Inc. not be used in
// advertising or publicity pertaining to distribution of the 
// Software without the prior specific, written permission of Cray
// Research, Inc.  The Software is a proprietary product of Cray
// Research, Inc., and all rights not specifically granted by this
// license shall remain in Cray Research, Inc.  No charge may be made
// for the use or distribution of the Software.  The Software may be
// distributed as a part of a different product for which a fee is
// charged, if (i) that product contains or provides substantial
// functionality that is additional to, or different from, the
// functionality of the Software, and (ii) no separate, special or
// direct charge is made for the Software.
//         
// THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
// IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
// FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
// VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
// DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
// INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
// SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
// CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
// PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
// INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
// CRAY RESEARCH.
// 
// This License Agreement shall be governed by, and interpreted and
// construed in accordance with, the laws of the State of Minnesota,
// without reference to its provisions on the conflicts of laws, and
// excluding the United Nations Convention of the International Sale
// of Goods.
//
//	USMID %Z%%M%	%I%	%G% %U%
//	$Id: Types.h++,v 1.2 1994/08/10 18:11:11 prb Exp $
//
#if	!defined(_Cvo_Types_)
#define _Cvo_Types_

#define ___mktype(a,b,c,d)		((a<<24)|(b<<16)|(c<<8)|d)

#define CvoT_Window			___mktype('C','W','i','n')
#define CvoT_LayoutWindow		___mktype('C','L','a','o')
#define CvoT_Object			___mktype('C','O','b','j')
#define CvoT_BasicObject		___mktype('C','v','o','*')

#define CvoT_Application		___mktype('A','p','p','l')
#define CvoT_BasicButton        	___mktype('B','u','t','n')
#define CvoT_BasicToggleButton        	___mktype('B','t','b','n')
#define CvoT_Blank			___mktype('B','l','n','k')
#define CvoT_Button             	___mktype('T','B','t','n')
#define CvoT_Chart	             	___mktype('C','h','r','t')
#define CvoT__Confirm		 	___mktype('C','f','r','m')
#define	CvoT_CutBufferWindow		___mktype('C','B','f','w')
#define CvoT_Frame			___mktype('F','r','m','e')
#define CvoT_Graph			___mktype('G','r','a','f')
#define CvoT_HoldWindow			___mktype('H','o','l','d')
#define CvoT_ImageButton        	___mktype('I','B','t','n')
#define CvoT__Inform		 	___mktype('I','n','f','m')
#define CvoT_Input		 	___mktype('I','p','u','t')
#define CvoT_InputOnly		 	___mktype('I','O','n','l')
#define CvoT_Label		 	___mktype('L','a','b','l')
#define CvoT_List		 	___mktype('L','i','s','t')
#define	CvoT_GenericList		___mktype('G','L','s','t')
#define CvoT_Menu		 	___mktype('M','e','n','u')
#define CvoT_ButtonMenu		 	___mktype('B','M','e','n')
#define CvoT_MenuBar		 	___mktype('M','B','a','r')
#define CvoT_MenuButton		 	___mktype('M','B','u','t')
#define CvoT_MenuToggle		 	___mktype('M','T','o','g')
#define CvoT_OpenFile		 	___mktype('O','F','i','l')
#define CvoT_Output		 	___mktype('O','p','u','t')
#define CvoT_Paint		 	___mktype('P','a','n','t')
#define CvoT_Pin		 	___mktype('P','i','n',0)
#define CvoT_SBAccessory		___mktype('S','B','A','c')
#define CvoT_SBBase			___mktype('S','B','B','s')
#define CvoT_SBThumb			___mktype('S','B','T','h')
#define CvoT_ScrollBar			___mktype('S','c','r','l')
#define CvoT_Separator			___mktype('S','e','p','r')
#define CvoT_SkyGraphic			___mktype('S','k','G','r')
#define CvoT_Skyline			___mktype('S','k','l','n')
#define CvoT_SquareToggle		___mktype('S','q','T','g')
#define CvoT_Text		 	___mktype('T','e','x','t')
#define CvoT_TextBoard		 	___mktype('T','B','r','d')
#define CvoT_TextViewPort	 	___mktype('T','x','V','P')
#define CvoT_Toggle			___mktype('T','o','g','l')
#define CvoT_ToggleButton		___mktype('T','g','B','t')
#define CvoT_SquareToggleButton		___mktype('S','q','T','B')
#define CvoT_Tree			___mktype('T','r','e','e')
#define CvoT_ViewPort		 	___mktype('V','w','P','t')
#define CvoT_WindowViewPort	 	___mktype('W','V','P','t')
#define CvoT_RadioBox		 	___mktype('R','B','o','x')

#endif
