//
// Copyright 1994, Cray Research, Inc.
//                 
// Permission to use, copy, modify and distribute this software and
// its accompanying documentation (the "Software") is granted without
// fee, provided that the above copyright notice and this permission
// notice appear in all copies of the Software and all supporting
// documentation, and the name of Cray Research, Inc. not be used in
// advertising or publicity pertaining to distribution of the 
// Software without the prior specific, written permission of Cray
// Research, Inc.  The Software is a proprietary product of Cray
// Research, Inc., and all rights not specifically granted by this
// license shall remain in Cray Research, Inc.  No charge may be made
// for the use or distribution of the Software.  The Software may be
// distributed as a part of a different product for which a fee is
// charged, if (i) that product contains or provides substantial
// functionality that is additional to, or different from, the
// functionality of the Software, and (ii) no separate, special or
// direct charge is made for the Software.
//         
// THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
// IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
// FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
// VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
// DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
// INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
// SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
// CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
// PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
// INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
// CRAY RESEARCH.
// 
// This License Agreement shall be governed by, and interpreted and
// construed in accordance with, the laws of the State of Minnesota,
// without reference to its provisions on the conflicts of laws, and
// excluding the United Nations Convention of the International Sale
// of Goods.
//
//	USMID %Z%%M%	%I%	%G% %U%
//	$Id: _Includes.h++,v 1.6 1994/08/10 18:11:11 prb Exp $
//
#include <Cvo/_ctype.h>
#include <stdio.h>
#include <stdlib.h>

#include <X11/Xlib.h>

#if !defined(XlibSpecificationRelease) || (XlibSpecificationRelease < 5)
#define	XlibSpecificationRelease 4
#define	X11R4
#endif

#if defined(X11R4)
extern __X11R4_was_not_to_build_this_Cvo_library;
static __xlib_consistancy_ref = __X11R4_was_not_to_build_this_Cvo_library;
#else
extern __X11R5_was_not_to_build_this_Cvo_library;
static __xlib_consistancy_ref = __X11R5_was_not_to_build_this_Cvo_library;
#endif

#include <Cvo/_Machine.h++>

#include <X11/Xmd.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/Xresource.h>
#include <X11/keysym.h>

typedef unsigned int CARD;
typedef int INT;

class Cvo_BasicObject;
class Cvo_Object;
class Cvo_LayoutWindow;
class Cvo_Window;
class Cvo_Pixmap;
class Cvo_Registration;

#if	!defined(_Cvo_Buffer_)
#include <Cvo/Buffer.h++>
#endif

#include <Cvo/util.h++>

#if	!defined(_Cvo_Quarks_)
#include <Cvo/Quarks.h++>
#endif
#if	!defined(_Cvo_Base_)
#include <Cvo/Base.h++>
#endif
#if	!defined(_Cvo_Types_)
#include <Cvo/Types.h++>
#endif
#if	!defined(_Cvo_Lock_)
#include <Cvo/Lock.h++>
#endif

extern CARD8 _cvo_butbitcnt[];
static inline int         
_cvo_button_count(XEvent *ev)  
{
    return(_cvo_butbitcnt[(ev->xbutton.state >> 8) & 0x1f]);
}   
