/*
 * Copyright 1994, Cray Research, Inc.
 *                 
 * Permission to use, copy, modify and distribute this software and
 * its accompanying documentation (the "Software") is granted without
 * fee, provided that the above copyright notice and this permission
 * notice appear in all copies of the Software and all supporting
 * documentation, and the name of Cray Research, Inc. not be used in
 * advertising or publicity pertaining to distribution of the 
 * Software without the prior specific, written permission of Cray
 * Research, Inc.  The Software is a proprietary product of Cray
 * Research, Inc., and all rights not specifically granted by this
 * license shall remain in Cray Research, Inc.  No charge may be made
 * for the use or distribution of the Software.  The Software may be
 * distributed as a part of a different product for which a fee is
 * charged, if (i) that product contains or provides substantial
 * functionality that is additional to, or different from, the
 * functionality of the Software, and (ii) no separate, special or
 * direct charge is made for the Software.
 *         
 * THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
 * IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
 * FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
 * VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
 * DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
 * INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
 * SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
 * CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
 * PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
 * INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
 * CRAY RESEARCH.
 * 
 * This License Agreement shall be governed by, and interpreted and
 * construed in accordance with, the laws of the State of Minnesota,
 * without reference to its provisions on the conflicts of laws, and
 * excluding the United Nations Convention of the International Sale
 * of Goods.
 *
 * 	USMID %Z%%M%	%I%	%G% %U%
 * 	$Id: pin.h,v 1.2 1994/08/10 18:11:11 prb Exp $
 */
static unsigned char in_dark_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00,
   0x00, 0x40, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
   0x00, 0x80, 0x00, 0x00, 0x00, 0xc0, 0x00, 0x00, 0x40, 0x40, 0x00, 0x00,
   0xc0, 0x71, 0x00, 0x00, 0x80, 0x3f, 0x00, 0x00, 0x00, 0x3e, 0x00, 0x00,
   0x18, 0x1c, 0x00, 0x00, 0xfc, 0x0f, 0x00, 0x00, 0xc6, 0x03, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00};
static unsigned char in_light_bits[] = {
   0x00, 0x0e, 0x00, 0x00, 0xc0, 0x11, 0x00, 0x00, 0x70, 0x00, 0x00, 0x00,
   0x48, 0x00, 0x00, 0x00, 0x24, 0x00, 0x00, 0x00, 0x24, 0x00, 0x00, 0x00,
   0x22, 0x00, 0x00, 0x00, 0x62, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00,
   0x06, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00,
   0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00};
static unsigned char out_dark_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x08, 0x00, 0x00, 0x04, 0x08,
   0x00, 0x00, 0x04, 0x08, 0x00, 0x00, 0x04, 0x08, 0x00, 0x00, 0x04, 0x08,
   0xc0, 0x7f, 0x04, 0x09, 0x00, 0x00, 0x04, 0x09, 0x00, 0x00, 0xfc, 0x09,
   0x06, 0x00, 0x04, 0x0f, 0x01, 0x00, 0x07, 0x06, 0x01, 0x00, 0x07, 0x00,
   0x00, 0x00, 0x03, 0x00};
static unsigned char out_light_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x80, 0x03, 0x06, 0x00, 0x80, 0x00, 0x01, 0x00, 0x80, 0xf8, 0x01,
   0x00, 0x80, 0x00, 0x01, 0x00, 0x80, 0x00, 0x01, 0xe0, 0xff, 0x00, 0x01,
   0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
   0x00, 0x80, 0x00, 0x00, 0x08, 0x80, 0x00, 0x00, 0x08, 0x80, 0x00, 0x00,
   0x06, 0x80, 0x00, 0x00};
